.386
.model flat,stdcall
option casemap:none

include	\masm32\include\windows.inc
include 	\masm32\include\kernel32.inc
include 	\masm32\include\user32.inc
include 	\masm32\include\gdi32.inc
include 	\masm32\include\oleaut32.inc
include 	\masm32\include\masm32.inc
include     IPicture.inc

includelib	\masm32\lib\kernel32.lib
includelib	\masm32\lib\user32.lib
includelib	\masm32\lib\gdi32.lib
includelib	\masm32\lib\masm32.lib
includelib	\masm32\lib\ole32.lib
includelib  \masm32\lib\oleaut32.lib

DlgProc     PROTO :DWORD,:DWORD,:DWORD,:DWORD
UnicodeStr  PROTO :DWORD,:DWORD

.data
IID_IPicture  GUID <7BF80980h,0BF32h,101Ah,<8Bh,0BBh,00h,0AAh,00h,30h,0Ch,0ABh>>
filename    db '\Fish.jpg',0


.data?
buffer      db 256 dup(?)
UnicodeName db 256 dup(?)
hBitmap     dd ?
pPicture    dd ?

.code

start:

    invoke  GetModuleHandle,NULL
    invoke  DialogBoxParam,eax,1000,NULL,ADDR DlgProc,NULL
    invoke  ExitProcess,eax

DlgProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

    LOCAL ps:PAINTSTRUCT
    LOCAL hdc:HDC
    LOCAL hMemDC:HDC
    LOCAL hTempBmp:DWORD

    .IF uMsg==WM_INITDIALOG
	
        invoke  GetCurrentDirectory,300,ADDR buffer
        invoke  lstrcat,ADDR buffer,ADDR filename
        invoke  UnicodeStr,ADDR buffer,ADDR UnicodeName
        invoke  OleLoadPicturePath,ADDR UnicodeName,0,0,0,ADDR IID_IPicture,ADDR pPicture

        lea     eax,[hTempBmp]
        push    eax
        mov     eax,pPicture
        push    eax
        mov     eax,DWORD PTR [eax]
        call    IPicture.get_Handle[eax]

        invoke  CopyImage,hTempBmp,IMAGE_BITMAP,0,0,LR_COPYRETURNORG
        mov     hBitmap,eax

        mov     eax,pPicture
        push    eax
        mov     eax,DWORD PTR [eax]
        call    IPicture.Release[eax]

    .ELSEIF uMsg==WM_PAINT
	
        invoke  BeginPaint,hWnd,ADDR ps
        mov     hdc,eax
        invoke  CreateCompatibleDC,eax
        mov     hMemDC,eax
        invoke  SelectObject,eax,hBitmap
        invoke  BitBlt,hdc,0,0,102,100,hMemDC,0,0,SRCCOPY
        invoke  DeleteDC,hMemDC
        invoke  EndPaint,hWnd,ADDR ps

    .ELSEIF uMsg==WM_CLOSE

        invoke  DeleteObject,hBitmap
        invoke  EndDialog,hWnd,NULL

    .ELSE

        mov eax,FALSE
        ret
        
    .ENDIF
    
    mov     eax,TRUE
    ret

DlgProc ENDP

UnicodeStr	PROC USES esi Source:DWORD,Dest:DWORD
                                                                        ; convert a string to UNICODE
    mov     esi,Source
    mov     edx,Dest
    xor     eax,eax
    sub     eax,1
@@:
    add     eax,1
    movzx   ecx,BYTE PTR [esi+eax]
    mov     WORD PTR [edx+eax*2],cx
    test    ecx,ecx
    jnz     @b
    ret

UnicodeStr	ENDP

END start

